/*
 *  Copyright (c) 2020-current NetApp
 *  All rights reserved
 */

// Code generated by lister-gen. DO NOT EDIT.

package v1alpha1

import (
	"k8s.io/apimachinery/pkg/api/errors"
	"k8s.io/apimachinery/pkg/labels"
	"k8s.io/client-go/tools/cache"
	v1alpha1 "quark.netapp.io/volume-controller/pkg/apis/volumecontroller/v1alpha1"
)

// NetAppSnapshotPolicyLister helps list NetAppSnapshotPolicies.
// All objects returned here must be treated as read-only.
type NetAppSnapshotPolicyLister interface {
	// List lists all NetAppSnapshotPolicies in the indexer.
	// Objects returned here must be treated as read-only.
	List(selector labels.Selector) (ret []*v1alpha1.NetAppSnapshotPolicy, err error)
	// NetAppSnapshotPolicies returns an object that can list and get NetAppSnapshotPolicies.
	NetAppSnapshotPolicies(namespace string) NetAppSnapshotPolicyNamespaceLister
	NetAppSnapshotPolicyListerExpansion
}

// netAppSnapshotPolicyLister implements the NetAppSnapshotPolicyLister interface.
type netAppSnapshotPolicyLister struct {
	indexer cache.Indexer
}

// NewNetAppSnapshotPolicyLister returns a new NetAppSnapshotPolicyLister.
func NewNetAppSnapshotPolicyLister(indexer cache.Indexer) NetAppSnapshotPolicyLister {
	return &netAppSnapshotPolicyLister{indexer: indexer}
}

// List lists all NetAppSnapshotPolicies in the indexer.
func (s *netAppSnapshotPolicyLister) List(selector labels.Selector) (ret []*v1alpha1.NetAppSnapshotPolicy, err error) {
	err = cache.ListAll(s.indexer, selector, func(m interface{}) {
		ret = append(ret, m.(*v1alpha1.NetAppSnapshotPolicy))
	})
	return ret, err
}

// NetAppSnapshotPolicies returns an object that can list and get NetAppSnapshotPolicies.
func (s *netAppSnapshotPolicyLister) NetAppSnapshotPolicies(namespace string) NetAppSnapshotPolicyNamespaceLister {
	return netAppSnapshotPolicyNamespaceLister{indexer: s.indexer, namespace: namespace}
}

// NetAppSnapshotPolicyNamespaceLister helps list and get NetAppSnapshotPolicies.
// All objects returned here must be treated as read-only.
type NetAppSnapshotPolicyNamespaceLister interface {
	// List lists all NetAppSnapshotPolicies in the indexer for a given namespace.
	// Objects returned here must be treated as read-only.
	List(selector labels.Selector) (ret []*v1alpha1.NetAppSnapshotPolicy, err error)
	// Get retrieves the NetAppSnapshotPolicy from the indexer for a given namespace and name.
	// Objects returned here must be treated as read-only.
	Get(name string) (*v1alpha1.NetAppSnapshotPolicy, error)
	NetAppSnapshotPolicyNamespaceListerExpansion
}

// netAppSnapshotPolicyNamespaceLister implements the NetAppSnapshotPolicyNamespaceLister
// interface.
type netAppSnapshotPolicyNamespaceLister struct {
	indexer   cache.Indexer
	namespace string
}

// List lists all NetAppSnapshotPolicies in the indexer for a given namespace.
func (s netAppSnapshotPolicyNamespaceLister) List(selector labels.Selector) (ret []*v1alpha1.NetAppSnapshotPolicy, err error) {
	err = cache.ListAllByNamespace(s.indexer, s.namespace, selector, func(m interface{}) {
		ret = append(ret, m.(*v1alpha1.NetAppSnapshotPolicy))
	})
	return ret, err
}

// Get retrieves the NetAppSnapshotPolicy from the indexer for a given namespace and name.
func (s netAppSnapshotPolicyNamespaceLister) Get(name string) (*v1alpha1.NetAppSnapshotPolicy, error) {
	obj, exists, err := s.indexer.GetByKey(s.namespace + "/" + name)
	if err != nil {
		return nil, err
	}
	if !exists {
		return nil, errors.NewNotFound(v1alpha1.Resource("netappsnapshotpolicy"), name)
	}
	return obj.(*v1alpha1.NetAppSnapshotPolicy), nil
}
