/*
 *  Copyright (c) 2020-current NetApp
 *  All rights reserved
 */

// Code generated by lister-gen. DO NOT EDIT.

package v1alpha1

import (
	"k8s.io/apimachinery/pkg/api/errors"
	"k8s.io/apimachinery/pkg/labels"
	"k8s.io/client-go/tools/cache"
	v1alpha1 "quark.netapp.io/volume-controller/pkg/apis/volumecontroller/v1alpha1"
)

// QuarkLister helps list Quarks.
// All objects returned here must be treated as read-only.
type QuarkLister interface {
	// List lists all Quarks in the indexer.
	// Objects returned here must be treated as read-only.
	List(selector labels.Selector) (ret []*v1alpha1.Quark, err error)
	// Quarks returns an object that can list and get Quarks.
	Quarks(namespace string) QuarkNamespaceLister
	QuarkListerExpansion
}

// quarkLister implements the QuarkLister interface.
type quarkLister struct {
	indexer cache.Indexer
}

// NewQuarkLister returns a new QuarkLister.
func NewQuarkLister(indexer cache.Indexer) QuarkLister {
	return &quarkLister{indexer: indexer}
}

// List lists all Quarks in the indexer.
func (s *quarkLister) List(selector labels.Selector) (ret []*v1alpha1.Quark, err error) {
	err = cache.ListAll(s.indexer, selector, func(m interface{}) {
		ret = append(ret, m.(*v1alpha1.Quark))
	})
	return ret, err
}

// Quarks returns an object that can list and get Quarks.
func (s *quarkLister) Quarks(namespace string) QuarkNamespaceLister {
	return quarkNamespaceLister{indexer: s.indexer, namespace: namespace}
}

// QuarkNamespaceLister helps list and get Quarks.
// All objects returned here must be treated as read-only.
type QuarkNamespaceLister interface {
	// List lists all Quarks in the indexer for a given namespace.
	// Objects returned here must be treated as read-only.
	List(selector labels.Selector) (ret []*v1alpha1.Quark, err error)
	// Get retrieves the Quark from the indexer for a given namespace and name.
	// Objects returned here must be treated as read-only.
	Get(name string) (*v1alpha1.Quark, error)
	QuarkNamespaceListerExpansion
}

// quarkNamespaceLister implements the QuarkNamespaceLister
// interface.
type quarkNamespaceLister struct {
	indexer   cache.Indexer
	namespace string
}

// List lists all Quarks in the indexer for a given namespace.
func (s quarkNamespaceLister) List(selector labels.Selector) (ret []*v1alpha1.Quark, err error) {
	err = cache.ListAllByNamespace(s.indexer, s.namespace, selector, func(m interface{}) {
		ret = append(ret, m.(*v1alpha1.Quark))
	})
	return ret, err
}

// Get retrieves the Quark from the indexer for a given namespace and name.
func (s quarkNamespaceLister) Get(name string) (*v1alpha1.Quark, error) {
	obj, exists, err := s.indexer.GetByKey(s.namespace + "/" + name)
	if err != nil {
		return nil, err
	}
	if !exists {
		return nil, errors.NewNotFound(v1alpha1.Resource("quark"), name)
	}
	return obj.(*v1alpha1.Quark), nil
}
